// drawDoc.h : interface of the CDrawDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAWDOC_H__40EE01EC_4409_11D2_9A63_CA3B8F3FF544__INCLUDED_)
#define AFX_DRAWDOC_H__40EE01EC_4409_11D2_9A63_CA3B8F3FF544__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include<fstream.h>

typedef struct
{
	char pb;
	unsigned char ceng;
	unsigned char ljsm;
	unsigned int pbh;
}LineStruMem;

typedef struct
{
	float x1;
	float x2;
	float y1;
	float y2;
	float z1;
	float z2;
	char cc;
	char linetype;
	char linewide;
}LineStruFile;


typedef struct
{
	float x;
	float y;
	float z;
}PointStru;


typedef struct
{
	char pb1;
	char pb2;
	int sm;
	int pbh;
	char cc;
	char cc1;
	char ceng;
	char ljsm;
	char linetype;
	char linewide;
}PlineStruMem;

typedef struct
{
	char pb1;
	char pb2;
	int pbh;
	char ceng;
	char ljsm;
}CircleStruMem;

typedef struct
{
	char pb;
	float x;
	float y;
	float z;
	float r;
	char cc;
	char cc1;
	char linetype;
	char linewide;
}CircleStruFile;

typedef struct
{
	char pb;
	int pbh;
	char ceng;
	char ljsm;
}TextStruMem;

typedef struct
{
	int pb;
	float x;
	float y;
	float high;
	float wide;
	float jg;
	float angl1;
	float angl2;
	char china[31];
	int sm;
	char cc;
	char font;
}TextStruFile;

typedef struct
{
	char pb;
	int pbh;
	char ceng;
	char ljsm;
}ArcStruMem;

typedef struct
{
	char pb;
	float x;
	float y;
	float r;
	float angl1;
	float angl2;
	char cc;
	char linetype;
	char linewide;
}ArcStruFile;





class Line:public CObject
{
protected:
LineStruMem* line;
LineStruFile line1;
fstream fline;
long l;
int LineNumb;

public:
	Line()
	{
		LineNumb=0;
		line=new LineStruMem[5000];
		fline.open("line.dat",ios::in|ios::out|ios::binary);
		if(fline.fail())
		{
		;//MsgBox("Class.file I/O error",vbOKOnly);//ϢӦ
		}
	}
	~Line()
	{
		delete line;
		fline.close();
	}
	void Read(int numb,int pb);
	void Draw1(CDC *pDC);
	void Draw(CDC *pDC);
	void Add(CPoint mPointOrign,CPoint mPointEnd);
	void Draw2(CClientDC *pDC,int pb);
};

class PLine:public CObject
{
protected:
	PlineStruMem* pline;
	PlineStruMem pline1;
	fstream fpline;
	int* MemList;
	long l;

public:
	int PLineNumb;

	PLine()
	{
		PLineNumb=0;
		pline=new PlineStruMem[5000];
		MemList=new int[3000];
		for(int i=0;i<3000;i++)
			MemList[i]=-1;
		fpline.open("pline.dat",ios::in|ios::out|ios::binary);
	}

	~PLine()
	{
		delete pline;
		delete MemList;
		fpline.close();
	}

	int PlineSave(int sm);
	int PlineRead(int pbh,int sm);
	int PlineDele(int pbh,int sm);
	int Add(int pb,int sm);
	void Draw1(CDC* pDC);
	void Draw(CDC* pDC);
	void Draw2(CClientDC* pDC,int pb);
};

class Circle:public CObject
{
protected:
	CircleStruMem* circle;
	CircleStruFile circle1;
	fstream fcircle;
	long l;
public:
	int CircleNumb;

	Circle()
	{
		CircleNumb=0;
		circle=new CircleStruMem[5000];
		fcircle.open("circle.dat",ios::in|ios::out|ios::binary);
	}

	~Circle()
	{
		delete circle;
		fcircle.close();
	}

	void Read(int numb,int pb);
	void Draw1(CDC* pDC);
	void Draw(CDC* pDC);
	void Add(CPoint mPointOrign,CPoint mPointEnd,int pb);
	void Draw2(CClientDC* pDC,int pb);
};

class Aarc:public CObject
{
protected:
	ArcStruMem* arc;
	ArcStruFile arc1;
	fstream farc;
	long l;

public:
	int ArcNumb;

	Aarc()
	{
		ArcNumb=1;
		arc=new ArcStruMem[5000];
		farc.open("arc.dat",ios::in|ios::out|ios::binary);
	}

	~Aarc()
	{
		delete arc;
		farc.close();
	}

	void Read(int umb,int pb);
};

class Text:public CObject
{
protected:
	TextStruMem* ttext;
	TextStruFile ttext1;
	fstream ftext;
	long l;

public:
	int TextNumb;

	Text()
	{
		TextNumb=0;
		ttext=new TextStruMem[5000];
		ftext.open("text.dat",ios::in|ios::out|ios::binary);
	}

	~Text()
	{
		delete ttext;
		ftext.close();
	}
	void Read(int numb,int pb);
};


class CDrawDoc : public CDocument
{
protected: // create from serialization only
	CDrawDoc();
	DECLARE_DYNCREATE(CDrawDoc)

// Attributes
public:

// Operations
public:
	Line Line1;
	PLine Pline1;
	Circle Circle1;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrawDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDrawDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDrawDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DRAWDOC_H__40EE01EC_4409_11D2_9A63_CA3B8F3FF544__INCLUDED_)
