// drawView.cpp : implementation of the CDrawView class
//

#include "stdafx.h"
#include "draw.h"

#include "drawDoc.h"
#include "drawView.h"
#include "mem1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CStatusBar m_wndStatusBar;
/////////////////////////////////////////////////////////////////////////////
// CDrawView

IMPLEMENT_DYNCREATE(CDrawView, CView)

BEGIN_MESSAGE_MAP(CDrawView, CView)
	//{{AFX_MSG_MAP(CDrawView)
	ON_COMMAND(ID_DRAW_CIRCLE, DrawCircle)
	ON_COMMAND(ID_DRAW_FCIRCLE, DrawFcircle)
	ON_COMMAND(ID_DRAW_LINE, DrawLine)
	ON_COMMAND(ID_DRAW_PLINE, DrawPline)
	ON_COMMAND(ID_DRAW_RECTANGLE, DrawRectangle)
	ON_COMMAND(ID_OPTION_INITIAL, OptionInitial)
	ON_COMMAND(ID_OPTION_PAN, OptionPan)
	ON_COMMAND(ID_OPTION_PREVIOUS, OptionPrevious)
	ON_COMMAND(ID_OPTION_REDRAW, OptionRedraw)
	ON_COMMAND(ID_OPTION_ZOOM, OptionZoom)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawView construction/destruction

CDrawView::CDrawView()
{
	// TODO: add construction code here
	startx=0.0;
	starty=0.0;
	blc=1.0;
	PushNumb=0;
	DrawCurrent=0;
	pbone=1;
	ScreenNumb=0;
	Screenxy[0][0]=startx;
	Screenxy[0][1]=starty;
	Screenxy[0][2]=blc;

}

CDrawView::~CDrawView()
{
}

BOOL CDrawView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView drawing

void CDrawView::OnDraw(CDC* pDC)
{
	CDrawDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
		if(pbone)
	{
		pbone=0;
		GetClientRect(&rr);
		ScreenWide=rr.right;
		ScreenHigh=rr.bottom;
	}
	pDoc->Line1.Draw(pDC);
	pDoc->Pline1.Draw(pDC);
	pDoc->Circle1.Draw(pDC);

}

/////////////////////////////////////////////////////////////////////////////
// CDrawView printing

BOOL CDrawView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDrawView::OnPrepareDC(CDC* pDC,CPrintInfo* pInfo)
{
	if(pInfo==NULL)
	return;
	int nRow=pInfo->m_nCurPage/nPageX+(pInfo->m_nCurPage%nPageX);
	int nCol=(pInfo->m_nCurPage-1)%nPageX+1;
	startx=xLeft+(nCol-1)*xPage;
	starty=yTop-(nRow-1)*yPage;
}

void CDrawView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add extra initialization before printing
	int mPageHeight,mPageWidth,nPage;
	xLeft=Screenxy[0][0];
	yBottom=Screenxy[0][1];
	xRight=xLeft+Screenxy[0][2]*ScreenWide;
	yTop=yBottom+Screenxy[0][2]*ScreenHigh;

	xWide=Screenxy[0][2]*ScreenWide;
	yHigh=Screenxy[0][2]*ScreenHigh;
	mPageHeight=pDC->GetDeviceCaps(VERTRES);
	mPageWidth=pDC->GetDeviceCaps(HORZRES);

	xPage=blc*mPageWidth;
	yPage=blc*mPageHeight;
	nPageX=(int)xWide/xPage+(xWide>xPage*(int)(xWide/xPage));
	nPageY=(int)yHigh/yPage+(yHigh>yPage*(int)(yHigh/yPage));
	nPage=nPageX*nPageY;
	pInfo->SetMinPage(1);
	pInfo->SetMaxPage(nPage);
	rr.right=mPageWidth;
	rr.bottom=mPageHeight;
	ScreenHigh=mPageHeight;
	ScreenWide=mPageWidth;

}

void CDrawView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
	startx=Screenxy[ScreenNumb][0];
	starty=Screenxy[ScreenNumb][1];
	pbone=1;
}

/////////////////////////////////////////////////////////////////////////////
// CDrawView diagnostics

#ifdef _DEBUG
void CDrawView::AssertValid() const
{
	CView::AssertValid();
}

void CDrawView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDrawDoc* CDrawView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawDoc)));
	return (CDrawDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDrawView message handlers

void CDrawView::SaveScreen()
{
	int i;
	if(ScreenNumb>=49)
	{
		for(i=1;i<ScreenNumb;i++)
		{
			Screenxy[i][0]=Screenxy[i+1][0];
			Screenxy[i][1]=Screenxy[i+1][1];
			Screenxy[i][2]=Screenxy[i+1][2];
		}
	}
	else
		ScreenNumb++;
	Screenxy[ScreenNumb][0]=startx;
	Screenxy[ScreenNumb][1]=starty;
	Screenxy[ScreenNumb][2]=blc;
}

void CDrawView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//	CView::OnLButtonDown(nFlags, point);
	CClientDC ht(this);
	CDrawDoc* pDoc=GetDocument();
	int x1,x2,y1,y2;
	float bl1,bl2;

	if(DrawCurrent==1)
	{
		if(PushNumb==0)
		{
			PushNumb++;
			mPointOrign=point;
			mPointOld=point;
			SetCapture();
		}
		else if(PushNumb==1)
		{
			pDoc->Line1.Add(mPointOrign,point);
			pDoc->Line1.Draw2(&ht,1);
			PushNumb=0;
			ReleaseCapture();
		}
	}
	else if(DrawCurrent==2||DrawCurrent==3)
	{
		Pointxy[PushNumb].x=startx+point.x*blc;
		Pointxy[PushNumb].y=starty+(ScreenHigh-point.y)*blc;
		if(PushNumb==0)
		{
			SetCapture();
			mPointOrign=point;
			mPointOld=point;
		}
		else
		{
			mPointOrign=mPointOld;
			mPointOld=point;
		}
		PushNumb++;
	}
	else if(DrawCurrent==4||DrawCurrent==5)
	{
		if(PushNumb==0)
		{
			PushNumb++;
			mPointOrign=point;
			mPointOld=point;
			SetCapture();
		}
		else
		{
			PushNumb=0;
			pDoc->Circle1.Add(mPointOrign,point,DrawCurrent-4);
			pDoc->Circle1.Draw2(&ht,1);
			ReleaseCapture();
		}
	}
	else if(DrawCurrent==20||DrawCurrent==21)
	{
		if(PushNumb==0)
		{
			mPointOrign=point;
			mPointOld=point;
			SetCapture();
			PushNumb++;
		}
		else if(PushNumb==1)
		{
			if(DrawCurrent==20)
			{
				x1=min(mPointOrign.x,point.x);
				y1=max(mPointOrign.y,point.y);
				x2=max(mPointOrign.x,point.x);
				y2=min(mPointOrign.y,point.y);
				startx=startx+x1*blc;
				starty=starty+(ScreenHigh-y1)*blc;
				bl1=(float)ScreenWide/(float)(x2-x1);
				bl2=(float)ScreenHigh/(float)(y1-y2);
				if(bl2<bl1)bl1=bl2;
				if(bl1>0)
					blc=blc/bl1;
			}
			else
			{
				startx=startx-(point.x-mPointOrign.x)*blc;
				starty=starty+(point.y-mPointOrign.y)*blc;
			}
			PushNumb=0;
			DrawCurrent=0;
			ReleaseCapture();
			Invalidate();
		}
	}
//	PushNumb=0;
//	DrawCurrent=0;
//	ReleaseCapture();
	SaveScreen();
//  Invalidate();
}

void CDrawView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CView::OnMouseMove(nFlags, point);
	CDrawDoc* pDoc=GetDocument();
	CClientDC ddd(this);
	CPen pen(0,0,RGB(0,0,0));
	int r;
	float xx,yy;
	char p1[20];
	xx=startx+point.x*blc;
	yy=starty+(ScreenHigh-point.y)*blc;
	sprintf(p1,"%f",xx);
	m_wndStatusBar.SetPaneText(2,p1,TRUE);
	sprintf(p1,"%f",yy);
	m_wndStatusBar.SetPaneText(3,p1,TRUE);
	CPen* pOldPen=ddd.SelectObject(&pen);
	ddd.SetROP2(R2_NOT);
	if(DrawCurrent==1&&PushNumb==1)
	{
		if(mPointOld!=point)
		{
			ddd.MoveTo(mPointOrign);
			ddd.LineTo(mPointOld);
			ddd.MoveTo(mPointOrign);
			ddd.LineTo(point);
			mPointOld=point;
		}
	}
	else if((DrawCurrent==2||DrawCurrent==3)&&PushNumb>=1)
	{
		if(mPointOld!=point)
		{
			ddd.MoveTo(mPointOrign);
			ddd.LineTo(mPointOld);
			ddd.MoveTo(mPointOrign);
			ddd.LineTo(point);
			mPointOld=point;
		}
	}
	else if((DrawCurrent==4||DrawCurrent==5)&&PushNumb>=1)
	{
		if(mPointOld!=point)
		{
			if(DrawCurrent==4)
				ddd.SelectStockObject(NULL_BRUSH);
			r=sqrt(pow((float)(mPointOrign.x-mPointOld.x),2)+pow((float)(mPointOrign.y-mPointOld.y),2));
			ddd.Ellipse(mPointOrign.x-r,mPointOrign.y-r,mPointOrign.x+r,mPointOrign.y+r);
			r=sqrt(pow((float)(mPointOrign.x-point.x),2)+pow((float)(mPointOrign.y-point.y),2));
			ddd.Ellipse(mPointOrign.x-r,mPointOrign.y-r,mPointOrign.x+r,mPointOrign.y+r);
			mPointOld=point;
		}
	}
	else if((DrawCurrent==20||DrawCurrent==21)&&PushNumb==1)
	{
		if(point!=mPointOld)
		{
			if(DrawCurrent==20)
			{
				ddd.SelectStockObject(NULL_BRUSH);
				ddd.Rectangle(mPointOrign.x,mPointOrign.y,mPointOld.x,mPointOld.y);
				ddd.Rectangle(mPointOrign.x,mPointOrign.y,point.x,point.y);
			}
			else 
			{
				ddd.MoveTo(mPointOrign);
				ddd.LineTo(mPointOld);
				ddd.MoveTo(mPointOrign);
				ddd.LineTo(point);
			}
			mPointOld=point;
		}
	}
	ddd.SelectObject(pOldPen);
}

void CDrawView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CView::OnRButtonDown(nFlags, point);
	CDrawDoc* pDoc=GetDocument();
	CClientDC ddd(this);
	CPen pen(0,0,RGB(0,0,0));
	int r;
	CPen* pOldPen=ddd.SelectObject(&pen);
	ddd.SetROP2(R2_NOT);
	if(DrawCurrent==1&&PushNumb==1)
	{
		ddd.MoveTo(mPointOrign);
		ddd.LineTo(mPointOld);
		PushNumb=0;
		ReleaseCapture();
	}
	else if((DrawCurrent==2||DrawCurrent==3)&&PushNumb>=1)
	{
		ddd.MoveTo(mPointOrign);
		ddd.LineTo(mPointOld);
		if(PushNumb>1)
		{
			pDoc->Pline1.Add(DrawCurrent,PushNumb);
			pDoc->Pline1.Draw2(&ddd,1);
		}
		PushNumb=0;
		ReleaseCapture();
	}
	else if((DrawCurrent==4||DrawCurrent==5)&&PushNumb>=1)
	{
		if(DrawCurrent==4)
				ddd.SelectStockObject(NULL_BRUSH);
			r=sqrt(pow((float)(mPointOrign.x-mPointOld.x),2)+pow((float)(mPointOrign.y-mPointOld.y),2));
			ddd.Ellipse(mPointOrign.x-r,mPointOrign.y-r,mPointOrign.x+r,mPointOrign.y+r);
			ReleaseCapture();
			PushNumb=0;

	}
	else if((DrawCurrent==20||DrawCurrent==21)&&PushNumb==1)
	{
		ddd.SelectStockObject(NULL_BRUSH);
		if(DrawCurrent==20)
			ddd.Rectangle(mPointOrign.x,mPointOrign.y,point.x,point.y);
		else
		{
			ddd.MoveTo(mPointOrign);
			ddd.LineTo(point);
		}
		ReleaseCapture();
		PushNumb=0;
	}
	ddd.SelectObject(pOldPen);
}

void CDrawView::DrawLine() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=1;
	
}

void CDrawView::DrawRectangle() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=3;
}

void CDrawView::DrawPline() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=2;
}

void CDrawView::DrawCircle() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=4;
}

void CDrawView::DrawFcircle() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=5;
}

void CDrawView::OptionPan() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=21;
}

void CDrawView::OptionRedraw() 
{
	// TODO: Add your command handler code here
	Invalidate();
	
}

void CDrawView::OptionZoom() 
{
	// TODO: Add your command handler code here
	PushNumb=0;
	DrawCurrent=20;
	
}

void CDrawView::OptionPrevious() 
{
	// TODO: Add your command handler code here
	if(ScreenNumb==0)
		return;
	ScreenNumb--;
	startx=Screenxy[ScreenNumb][0];
	starty=Screenxy[ScreenNumb][1];
	blc=Screenxy[ScreenNumb][2];
	Invalidate();
}

void CDrawView::OptionInitial() 
{
	// TODO: Add your command handler code here
	if(ScreenNumb==0)
		return;
	ScreenNumb=0;
	startx=Screenxy[0][0];
	starty=Screenxy[0][1];
	blc=Screenxy[0][2];
	Invalidate();
}


